Bug 836749 - Review Request: objconv - object file converter and disassembler
Review Request: objconv - object file converter and disassembler
Status: CLOSED NOTABUG
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Nobody's working on this, feel free to take it
Fedora Extras Quality Assurance
:
Depends On:
Blocks: FE-DEADREVIEW
  Show dependency treegraph
 
Reported: 2012-06-30 18:05 EDT by Tim Sally
Modified: 2015-12-03 23:49 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-12-03 23:49:36 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Tim Sally 2012-06-30 18:05:55 EDT
Spec URL: http://www.atomicpeace.com/objconv/objconv.spec
SRPM URL: http://www.atomicpeace.com/objconv/objconv-2.14-1.fc17.src.rpm
Description: objconv can be used to convert between object files such as COFF/PE and ELF. It provides some object editing capabilities, including changing symbol names. It includes a disassembler that supports many x86 extensions.

Fedora Account System Username: tsally
Comment 1 Tim Sally 2012-06-30 18:07:18 EDT
Here are the rpmlint and koji results.

[tsally@goddard SPECS]$ rpmlint -i objconv.spec ../RPMS/x86_64/objconv-2.14-1.fc17.x86_64.rpm ../RPMS/x86_64/objconv-debuginfo-2.14-1.fc17.x86_64.rpm ../SRPMS/objconv-2.14-1.fc17.src.rpm 
objconv.x86_64: W: spelling-error Summary(en_US) disassembler -> disassemble, disassembles, disassembled
The value of this tag appears to be misspelled. Please double-check.

objconv.x86_64: W: spelling-error %description -l en_US disassembler -> disassemble, disassembles, disassembled
The value of this tag appears to be misspelled. Please double-check.

objconv.x86_64: W: no-manual-page-for-binary objconv
Each executable in standard binary directories should have a man page.

objconv.src: W: spelling-error Summary(en_US) disassembler -> disassemble, disassembles, disassembled
The value of this tag appears to be misspelled. Please double-check.

objconv.src: W: spelling-error %description -l en_US disassembler -> disassemble, disassembles, disassembled
The value of this tag appears to be misspelled. Please double-check.

3 packages and 1 specfiles checked; 0 errors, 5 warnings.

[tsally@goddard ~]$ koji build --scratch f17 rpmbuild/SRPMS/objconv-2.14-1.fc17.src.rpm 
Uploading srpm: rpmbuild/SRPMS/objconv-2.14-1.fc17.src.rpm
[====================================] 100% 00:00:02 489.23 KiB 201.80 KiB/sec
Created task: 4210216
Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=4210216
Watching tasks (this may be safely interrupted)...
4210216 build (f17, objconv-2.14-1.fc17.src.rpm): free
4210216 build (f17, objconv-2.14-1.fc17.src.rpm): free -> open (x86-15.phx2.fedoraproject.org)
  4210218 buildArch (objconv-2.14-1.fc17.src.rpm, i686): free
  4210217 buildArch (objconv-2.14-1.fc17.src.rpm, x86_64): free
  4210217 buildArch (objconv-2.14-1.fc17.src.rpm, x86_64): free -> open (x86-17.phx2.fedoraproject.org)
  4210218 buildArch (objconv-2.14-1.fc17.src.rpm, i686): free -> open (x86-03.phx2.fedoraproject.org)
  4210217 buildArch (objconv-2.14-1.fc17.src.rpm, x86_64): open (x86-17.phx2.fedoraproject.org) -> closed
  0 free  2 open  1 done  0 failed
  4210218 buildArch (objconv-2.14-1.fc17.src.rpm, i686): open (x86-03.phx2.fedoraproject.org) -> closed
  0 free  1 open  2 done  0 failed
4210216 build (f17, objconv-2.14-1.fc17.src.rpm): open (x86-15.phx2.fedoraproject.org) -> closed
  0 free  0 open  3 done  0 failed

4210216 build (f17, objconv-2.14-1.fc17.src.rpm) completed successfully
Comment 2 Tim Sally 2012-06-30 18:10:11 EDT
There are 5 total warnings, 2 of which are unique. The spelling warning is incorrect, as disassembler is a word. The warning about a man page is valid, however no man page is provided upstream. Thankfully this package is heavily documented in other ways, included an extensive manual and detailed help on the command line.
Comment 3 David Cameron 2012-07-18 06:22:30 EDT
Hi,

Here is a first (informal) review:

Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated



==== C/C++ ====
[x]: MUST Header files in -devel subpackage, if present.
[x]: MUST Package does not contain any libtool archives (.la)
[x]: MUST Package does not contain kernel modules.
[x]: MUST Package contains no static executables.
[x]: MUST Rpath absent or only used for internal libs.
[x]: MUST Package is not relocatable.


==== Generic ====
[x]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: MUST Buildroot is not present
     Note: Unless packager wants to package for EPEL5 this is fine
[x]: MUST Package contains no bundled libraries.
[x]: MUST Changelog in prescribed format.
[x]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean would be needed if support for EPEL is required
[x]: MUST Sources contain only permissible code or content.
[x]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: Note: defattr macros not found. They would be needed for EPEL5
[-]: MUST Macros in Summary, %description expandable at SRPM build time.
[-]: MUST Package requires other packages for directories it uses.
[x]: MUST Package uses nothing in %doc for runtime.
[x]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[!]: MUST Spec file lacks Packager, Vendor, PreReq tags.
     Note: Found : Vendor: Agner Fog
[x]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf would be needed if support for EPEL5 is required
[-]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[!]: MUST License field in the package spec file matches the actual license.
     Note: Upstream website states license as GPL, while in spec it is GPLv3+
[x]: MUST Package consistently uses macros (instead of hard-coded directory
     names).
[x]: MUST Package meets the Packaging Guidelines.
[x]: MUST Package is named according to the Package Naming Guidelines.
[x]: MUST Package does not generates any conflict.
[x]: MUST Package obeys FHS, except libexecdir and /usr/target.
[-]: MUST Package must own all directories that it creates.
[x]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[-]: MUST Requires correct, justified where necessary.
[!]: MUST Rpmlint output is silent.

rpmlint objconv-debuginfo-2.14-1.fc18.i686.rpm

1 packages and 0 specfiles checked; 0 errors, 0 warnings.


rpmlint objconv-2.14-1.fc18.i686.rpm

objconv.i686: W: spelling-error Summary(en_US) disassembler -> disassemble, disassembles, disassembled
objconv.i686: W: spelling-error %description -l en_US disassembler -> disassemble, disassembles, disassembled
1 packages and 0 specfiles checked; 0 errors, 2 warnings.


rpmlint objconv-2.14-1.fc18.src.rpm

objconv.src: W: spelling-error Summary(en_US) disassembler -> disassemble, disassembles, disassembled
objconv.src: W: spelling-error %description -l en_US disassembler -> disassemble, disassembles, disassembled
objconv.src:30: E: files-attr-not-set
objconv.src:31: E: files-attr-not-set
objconv.src: W: no-cleaning-of-buildroot %install
objconv.src: W: no-cleaning-of-buildroot %clean
objconv.src: W: no-buildroot-tag
objconv.src: W: no-%clean-section
1 packages and 0 specfiles checked; 2 errors, 6 warnings.


[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
/home/mock/836749/objconv-2.14.tar.gz :
  MD5SUM this package     : 211614a017ace5c196fcd3ffe6db3b45
  MD5SUM upstream package : 211614a017ace5c196fcd3ffe6db3b45

[!]: MUST Spec file is legible and written in American English.
     Note: formatting is not consistent with Fedora template - the tag
     values are not aligned vertically
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: MUST Package contains a SysV-style init script if in need of one.
[x]: MUST File names are valid UTF-8.
[x]: SHOULD Reviewer should test that the package builds in mock.
[?]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[x]: SHOULD Dist tag is present.
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[x]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[?]: SHOULD Package functions as described.
[x]: SHOULD Package does not include license text files separate from
     upstream.
[x]: SHOULD SourceX is a working URL.
[-]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[-]: SHOULD %check is present and all tests pass.
[!]: SHOULD Packages should try to preserve timestamps of original installed
     files.
     Note: Manual in package has a newer timestamp (and different size) than manual linked on webpage

> ls -l /usr/share/doc/objconv-2.14/
total 228
-rw-r--r--. 1 root root 231276 Jun 30 21:31 objconv-instructions.pdf
> wget -N http://www.agner.org/optimize/objconv-instructions.pdf
> ls -l objconv-instructions.pdf 
-rw-r--r--. 1 mock mock 231271 Aug  3  2011 objconv-instructions.pdf

[x]: SHOULD Spec use %global instead of %define.

Issues:
[!]: MUST Spec file lacks Packager, Vendor, PreReq tags.
     Note: Found : Vendor: Agner Fog
[!]: MUST Rpmlint output is silent.

rpmlint objconv-debuginfo-2.14-1.fc18.i686.rpm

1 packages and 0 specfiles checked; 0 errors, 0 warnings.


rpmlint objconv-2.14-1.fc18.i686.rpm

objconv.i686: W: spelling-error Summary(en_US) disassembler -> disassemble, disassembles, disassembled
objconv.i686: W: spelling-error %description -l en_US disassembler -> disassemble, disassembles, disassembled
1 packages and 0 specfiles checked; 0 errors, 2 warnings.


rpmlint objconv-2.14-1.fc18.src.rpm

objconv.src: W: spelling-error Summary(en_US) disassembler -> disassemble, disassembles, disassembled
objconv.src: W: spelling-error %description -l en_US disassembler -> disassemble, disassembles, disassembled
objconv.src:30: E: files-attr-not-set
objconv.src:31: E: files-attr-not-set
objconv.src: W: no-cleaning-of-buildroot %install
objconv.src: W: no-cleaning-of-buildroot %clean
objconv.src: W: no-buildroot-tag
objconv.src: W: no-%clean-section
1 packages and 0 specfiles checked; 2 errors, 6 warnings.




Generated by fedora-review 0.1.2


Summary of issues:

1. There must be no Vendor tag in spec
2. License inconsistency between package and upstream 
3. rpmlint is not silent, but spelling-error should be allowed and others can be ignored if not building for EPEL5
4. Installed manual has newer timestamp than original from upstream
5. Format of tags in spec file should be consistent with Fedora template
6. No man page for binary, as you acknowledged already.
Comment 4 Tim Sally 2012-07-18 12:14:34 EDT
David,

Thanks a lot for the informal review. In regards to the license, the project is GPL3. Please see the below personal communication with the author:
--
From agner@agner.org  Sun Jul  1 02:53:03 2012                                                                                                      
Return-Path: <agner@agner.org>                                                                                                                      
X-Original-To: tsally@atomicpeace.com                                                                                                               
Delivered-To: tsally@atomicpeace.com                                                                                                                                                                                     
Message-ID: <4FEFF3A5.9060509@agner.org>                                                                                                            
Date: Sun, 01 Jul 2012 08:52:21 +0200                                                                                                               
From: Agner Fog <agner@agner.org>                                                                                                                   
Organization: agner@agner.org                                                                                                                       
User-Agent: Mozilla/5.0 (Windows NT 5.1; rv:12.0) Gecko/20120428 Thunderbird/12.0.1                                                                 
MIME-Version: 1.0                                                                                                                                   
To: Tim Sally <tsally@atomicpeace.com>                                                                                                              
Subject: Re: Which version of GPL for objconv?                                                                                                      
References: <20120630192315.GA13389@atomicpeace.com>                                                                                                
In-Reply-To: <20120630192315.GA13389@atomicpeace.com>                                                                                               
Content-Type: text/plain; charset=ISO-8859-1; format=flowed                                                                                         
Content-Transfer-Encoding: 7bit                                                                                                                     
Status: RO                                                                                                                                          
Content-Length: 193                                                                                                                                 
Lines: 12                                                                                                                                           

version 3.0

On 30-06-2012 21:23, Tim Sally wrote:
> Hi Anger,                                                                                                                                         
>                                                                                                                                                   
> Thank you very much for writing objconv! I know it is GPL licensed, but                                                                           
> I am wondering which version?                                                                                                                     
>                                                                                                                                                   
> Thanks,                                                                                                                                           
>                                                                                                                                                   
> Tim                                                                                                                                               
>   
--

As to the other issues, I will generate a new spec addressing them tonight!

Thanks again for the review,

Tim
Comment 5 Miroslav Suchý 2015-07-21 09:43:03 EDT
Ping!
Any progress here?
Comment 6 James Hogarth 2015-12-03 23:49:36 EST
As per the stalled review policy this bug is being closed as the requester has not responded to a needs info in over a year.

https://fedoraproject.org/wiki/Policy_for_stalled_package_reviews

Note You need to log in before you can comment on or make changes to this bug.